#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include <mpi.h>

int main(int argc, char **argv)
{
    int i, j, k;
    double start, end, sum;
    int myrank, gsize;
    int count, len, startlen, step;
    double *buf = NULL;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Comm_size(MPI_COMM_WORLD, &gsize);
    
    if(argc != 5){
        printf("usage: send_test <start_length> <max_length> <step> <max_count>\n");
        return -1;
    }
    startlen = atoi(*(argv+1));
    len = atoi(*(argv+2));
    step = atoi(*(argv+3));
    count = atoi(*(argv+4));

    if(len <= 0 || count <= 0 || step <= 0|| startlen >= len){
        printf("cannot read startlen or len or count\n");
        return -1;
    }
    buf = (double *)malloc(sizeof(double) * len * gsize);
    if(buf == NULL){
        printf("buf allocate error\n");
        return -1;
    }
    srand((unsigned)time(NULL));

////////////////////////////////////////
// 񏈗
    if(myrank == 0){
        printf("Alltoall test. startlen = %d len = %d, step = %d, count = %d,gsize = %d\n", startlen, len, step, count, gsize);
    }
    for(i = startlen; i < len; i += step){
        sum = 0.0;
        for(j = 0; j < count; j++){
            if(myrank == 0){
                for(k = 0; k < i * gsize; k++){
                    buf[k] = rand() / 29;
                }
                
                start = MPI_Wtime();
                MPI_Alltoall(buf, i, MPI_DOUBLE, buf, i, MPI_DOUBLE, 
			     MPI_COMM_WORLD);
                end = MPI_Wtime();
                sum += (end - start);
            }else{
                MPI_Alltoall(buf, i, MPI_DOUBLE, buf, i, MPI_DOUBLE, 
			     MPI_COMM_WORLD);
            }
        }
        if(myrank == 0){
            printf("len=%d:\t%f msec\n", i, (sum * 1000) / count);
        }
    }
    MPI_Finalize();
    
    return 0;
}
